﻿
angular.module('wjm', ['ui.bootstrap', 'ui.calendar', 'angularTreeview', 'ngDialog']).

           controller('resourceCtrl', function ($scope, uiCalendarConfig, $compile, ngDialog , $timeout) {
               var vm = $scope;

               var date = new Date();

               var d = date.getDate();
               var m = date.getMonth();
               var y = date.getFullYear();
               var hubber = $.connection.calendarHub;
               vm.alertMessage = "No alerts";
               vm.currentcal = [];
               vm.selectedEventId = -1;

               vm.init = function () {

                   //  $.connection.hub.logging = true;


                   var v = document.getElementById("userId").innerHTML;
                   $.connection.hub.qs = { 'userid': v };
                   $.connection.hub.start().done(function () {
                       hubber.server.requestInfo();
                   });
                   hubber.client.processData = function (data) {
                       vm.data = JSON.parse(data);
                       $scope.buildTree();

                       $scope.$apply();
                   };
                   hubber.client.processDowntime = function (id, down) {
                       var json = JSON.parse(down);
                       var arrdown = [];
                       var str = "";
                       var col = "";
                       for (var i = 0; i < json.length; i++) {
                           if (json[i].DowntimeType === 0) {
                               str = "Unavailable";
                               col = "#006080";
                           }
                           else {
                               str = "Shutdown";
                               col = "#993300";
                           }
                           arrdown.push({
                               id: json[i].Id,
                               title: str,
                               start: new Date(json[i].StartDate),
                               end: new Date(json[i].EndDate),
                               allDay: json[i].AllDayEvent,
                               color: col
                           });
                       }
                       var dat = { 'id': id, 'down': [arrdown] };
                       $scope.treeview.currentNode.calendar = dat;

                       $scope.currentcal = $scope.treeview.currentNode.calendar;
                       $scope.$apply();
                   }

                   $scope.$watch("treeview.currentNode", function (newValue, oldValue) {
                       $scope.currentcal = [];
                       $(".selected.ng-binding").addClass('loaded');
                       $scope.selectedEventId = -1;
                       if ($scope.treeview.currentNode != null) {
                           if ($scope.treeview.currentNode.calendar.length === 0) {
                               hubber.server.requestDownTime(vm.treeview.currentNode.Id);

                           }
                           else {
                               $timeout(function () {
                                   $scope.currentcal = $scope.treeview.currentNode.calendar;

                               }, 0);

                           }
                       }

                   });
               }
               $scope.saveCurrentCalendar = function () {
                   console.log("Save Current cal");
               }
               $scope.saveAllCalendars = function () {
                   console.log("Save all");
               }
               $scope.clearCurrentCalendar = function () {
                   
                   $scope.selectedEventId = -1;
                   $scope.treeview.currentNode.calendar = null;
                   $scope.currentcal = [];
                   hubber.server.requestDownTime(vm.treeview.currentNode.Id);
                   $(".selected.ng-binding").removeClass('changed');
               }
               $scope.clearAllCalendars = function () {
                   ngDialog.openConfirm({
                       template:
                        '<p>Are you sure you want to delete all calendar changes?</p>' +
                        '<div>' +
                          '<button type="button" class="btn btn-default" ng-click="closeThisDialog(0)">No </button> ' +
                          '<button type="button" class="btn btn-primary" ng-click="confirm(1)">Yes' +
                        '</button></div>',
                       plain: true
                   }).then(function (success) {
                       $(".ng-binding.changed").removeClass('changed');
                       $(".ng-binding.loaded").removeClass('loaded');
                       $scope.selectedEventId = -1;
                       $scope.treeview.currentNode.calendar = null;
                       $scope.currentcal = [];
                       for (var i = 0; i < $scope.tree.length; i++)
                           removeCalendarsRecurse($scope.tree[i]);
                       hubber.server.requestDownTime(vm.treeview.currentNode.Id);
                       $(".selected.ng-binding").addClass('loaded');
                   });
                  
               }
               function removeCalendarsRecurse(node) {

                   node.calendar = [];
                   node.todelete = [];

                   for (var i = 0; i < node.children.length; i++) {
                       removeCalendarsRecurse(node.children[i]);
                   }
               }

               $scope.buildTree = function () {
                   vm.tree = [];
                   vm.temptree = [];
                   vm.top = false;
                   for (; vm.data.length > 0;) {

                       if (vm.data[0].ParentResourceId == null) {
                           var curr = $scope.seekChildren(vm.data.splice(0, 1)[0]);
                           vm.tree.push(curr);
                       }
                       else {
                           var curr = $scope.seekChildren(vm.data.splice(0, 1)[0]);
                           vm.temptree.push(curr);
                       }
                   }

               };

               $scope.seekChildren = function (current) {
                   current.calendar = [];
                   current.children = [];
                   current.todelete = [];
                   current.collapsed = true;
                   for (var t = 0; t < vm.temptree.length;) {
                       if (current.Id == vm.temptree[t].ParentResourceId) {
                           current.children.push(vm.temptree.splice(t, 1)[0]);
                       }
                       else {
                           t++;
                       }
                   }
                   var childc = current.children.length;//Remembers count of children received from temp tree;
                   for (var t = 0; t < vm.data.length;) {
                       if (current.Id == vm.data[t].ParentResourceId) {
                           current.children.push(vm.data.splice(t, 1)[0]);
                       }
                       else {
                           t++;
                       }
                   }
                   for (var t = childc; t < current.children.length; t++) {
                       current.children[t] = $scope.seekChildren(current.children[t]);
                   }
                   return current;
               }
               function checkId(id) {
                   for (var i = 0; i < vm.treeview.currentNode.calendar.down[0].length ; i++) {
                       if (vm.treeview.currentNode.calendar.down[0][i]._id === id)
                           return i;
                   }
                   return -1;
               }
               $scope.setChanged = function () {
                   if (vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].title === "Unavailable")
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].color = '#0099cc';
                   else
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].color = '#ff5500';
                   vm.treeview.currentNode.changes = true;
                   $(".selected.ng-binding").addClass('changed');
               }
               //*Add event by click
               $scope.calendarClick = function (date, jsEvent, view) {
                   var newid = 0;
                   if (vm.treeview.currentNode.calendar.down[0].length != 0)
                       newid = vm.treeview.currentNode.calendar.down[0][(vm.treeview.currentNode.calendar.down[0].length - 1)]._id + 1;
                   vm.treeview.currentNode.calendar.down[0].push({
                       id: '00000000-0000-0000-0000-000000000000',
                       title: 'Unavailable',
                       start: date.toDate(),
                       end: null,
                       allDay: date._ambigTime,
                       _id: (newid)
                   });

                   vm.selectedEventId = vm.treeview.currentNode.calendar.down[0].length - 1;
                   vm.setChanged();

               }
               /* alert on eventClick */
               $scope.alertOnEventClick = function (date, jsEvent, view) {
                   vm.selectedEventId = checkId(date._id);
               };
               /* alert on Drop */
               $scope.alertOnDrop = function (event, delta, revertFunc, jsEvent, ui, view) {
                   vm.selectedEventId = checkId(event._id);
                   vm.setChanged();
                   if (vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].allDay && event.start._ambigTime == false) {
                       event.allDay = false;
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].allDay = false;
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].end = null;
                   }
                   else if (!vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].allDay && event.start._ambigTime == true) {
                       event.allDay = true;
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].allDay = true;
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].end = null;
                   }
                   vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].start = new Date(event.start);
                   if (vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].end != null)
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].end = new Date(event.end);
               };
               /* alert on Resize */
               $scope.alertOnResize = function (event, delta, revertFunc, jsEvent, ui, view) {
                   vm.selectedEventId = checkId(event._id);
                   vm.setChanged();
                   vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].start = new Date(event.start);
                   vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].end = new Date(event.end);
               };

               /* add custom event*/
               $scope.addEvent = function () {

               };

               /* remove event */
               $scope.remove = function (index) {
                   vm.selectedEventId = -1;
                   if (vm.treeview.currentNode.calendar.down[0][index].id != "00000000-0000-0000-0000-000000000000") {
                       vm.treeview.currentNode.todelete.push(vm.treeview.currentNode.calendar.down[0][index - 1].id);
                   }
                   vm.treeview.currentNode.calendar.down[0].splice(index, 1);


               };
               /* Render Tooltip */
               $scope.eventRender = function (event, element, view) {
                   element.attr({
                       'tooltip': event.title,
                       'tooltip-append-to-body': true
                   });
                   //$compile(element)($scope);
               };
               /* config object */
               $scope.uiConfig = {
                   calendar: {
                       height: 500,
                       editable: true,
                       defaultView: 'agendaWeek',
                       firstDay: 1,
                       header: {
                           left: 'title',
                           center: '',
                           right: 'today prev,next'
                       },
                       timezone: 'UTC',
                       timeFormat: 'HH:mm',
                       eventClick: $scope.alertOnEventClick,
                       eventDrop: $scope.alertOnDrop,
                       eventResize: $scope.alertOnResize,
                       eventRender: $scope.eventRender,
                       dayClick: $scope.calendarClick


                   }
               };

           });


